#include <stdlib.h>
#include <stdio.h>
#include <stdint.h>
#include <sysexits.h>
#include <getopt.h>
#include <arpa/inet.h>
#include <errno.h>
#include <fcntl.h>
#include <string.h>
#include <unistd.h>
#include <sys/stat.h>
#ifdef __linux__
#include <byteswap.h>
#endif
#include "declrom.h"

void usage(const char *pname) {
	return;
}

int main(int argc, char *argv[]) {
	char c = 0;
	int loptind = 0;
	char *infile = NULL;
	struct option o[] = {
		{"help", 0, 0, 'h'},
		{"input", 1, 0, 'i'},
		{0,0,0,0}
	};

	while( (c = getopt_long(argc, argv, "hi:", o, &loptind)) != -1 ) {
		switch(c) {
		case 'i':
			if(!optarg) {
				usage(argv[0]);
				exit(EX_USAGE);
			}
			infile = optarg;
			break;
		case 'h':
			usage(argv[0]);
			exit(EX_USAGE);
			break;
		}
	}

	if(!infile) {
		usage(argv[0]);
		exit(EX_USAGE);
	}
	errno = 0;

	sDeclRom *rom = sdeclrom_readfile(infile);
	if(!rom) {
		fprintf(stderr, "Error reading rom file\n");
		exit(EX_CONFIG);
	}

	printf("bytelanes = %x\n", rom->formatblock.bytelanes);
	printf("testpattern = %x\n", rom->formatblock.testpattern);
	printf("format = %x\n", rom->formatblock.format);
	printf("revision = %x\n", rom->formatblock.revision);
	printf("crc = %x\n", rom->formatblock.crc);
	printf("length = %x\n", rom->formatblock.length);
	printf("offset = %d\n", rom->formatblock.diroffset);

	sdeclrom_writefile(rom, "foorom.bin");

	exit(0);
}
